addhook("projectile_impact","build_base")


projectileList = {SmokeGrenade = 53, Molotov = 73}

function build_base(id, weapon, x, y, mode, projectid)
    if projectile(projectid, id, "type") == projectileList.SmokeGrenade then
        build_rectangle_base(id, projectid)
    elseif projectile(projectid, id, "type") == projectileList.Molotov then
        build_large_base(id, projectid)
    end
end

function build_rectangle_base(id, projectid)
    local xd = math.floor(projectile(projectid, id, "x") / 32)
    local yd = math.floor(projectile(projectid, id, "y") / 32)
    local team = player(id, "team")

    for i = 1, 4 do
        for j = 1, 4 do
            if team == 1 then
                spawn_objects_for_team_1(xd, yd, i, j, id)
            elseif team == 2 then
                spawn_objects_for_team_2(xd, yd, i, j, id)
            end
        end
    end
end

function build_large_base(id, projectid)
    local xd = math.floor(projectile(projectid, id, "x") / 32)
    local yd = math.floor(projectile(projectid, id, "y") / 32)
    local team = player(id, "team")
    local baseCenterX = xd + 2
    local baseCenterY = yd + 2

    for i = 0, 4 do
        for j = 0, 4 do
            if team == 1 then
                spawn_walls_and_turrets_for_team_1(xd, yd, i, j, id, baseCenterX, baseCenterY)
            elseif team == 2 then
                spawn_walls_and_turrets_for_team_2(xd, yd, i, j, id, baseCenterX, baseCenterY)
            end
        end
    end
end

function spawn_objects_for_team_1(xd, yd, i, j, id)
    if i > 1 and i < 4 and j > 1 and j < 4 then
        parse("spawnobject 6 " .. xd + i .. " " .. (yd + j) .. " 0 0 1 " .. id) -- Gate field
    elseif (i == 1 or i == 4) and (j == 1 or j == 4) then
        parse("spawnobject 11 " .. xd + i .. " " .. (yd + j) .. " 0 0 1 " .. id) -- Dual Turret
    else
        parse("spawnobject 1 " .. xd + i .. " " .. (yd + j) .. " 0 0 1 " .. id) -- Barricade
    end
end

function spawn_objects_for_team_2(xd, yd, i, j, id)
    if i > 1 and i < 4 and j > 1 and j < 4 then
        parse("spawnobject 6 " .. xd + i .. " " .. (yd + j) .. " 0 0 2 " .. id) -- Gate field
    elseif (i == 1 or i == 4) and (j == 1 or j == 4) then
        parse("spawnobject 11 " .. xd + i .. " " .. (yd + j) .. " 0 0 2 " .. id) -- Dual Turret
    else
        parse("spawnobject 1 " .. xd + i .. " " .. (yd + j) .. " 0 0 2 " .. id) -- Barricade
    end
end

function spawn_walls_and_turrets_for_team_1(xd, yd, i, j, id, baseCenterX, baseCenterY)
    if i == 0 or i == 4 or j == 0 or j == 4 then
        parse("spawnobject 5 " .. (xd + i) .. " " .. (yd + j) .. " 0 0 1 " .. id) -- Wall II
    end

    if (i == 1 or i == 4) and (j == 1 or j == 4) then
        parse("spawnobject 12 " .. (baseCenterX - 1 + i) .. " " .. (baseCenterY - 1 + j) .. " 0 0 1 " .. id) -- Triple Turret
    end

    if i > 0 and i < 4 and j > 0 and j < 4 then
        parse("spawnobject 6 " .. (baseCenterX + i - 1) .. " " .. (baseCenterY + j - 1) .. " 0 0 1 " .. id) -- Gate field
    end
end

function spawn_walls_and_turrets_for_team_2(xd, yd, i, j, id, baseCenterX, baseCenterY)
    if i == 0 or i == 4 or j == 0 or j == 4 then
        parse("spawnobject 5 " .. (xd + i + 1) .. " " .. (yd + j) .. " 0 0 1 " .. id) -- Wall II
    end

    if (i == 1 or i == 4) and (j == 1 or j == 4) then
        parse("spawnobject 12 " .. (baseCenterX + i) .. " " .. (baseCenterY - 1 + j) .. " 0 0 2 " .. id) -- Triple Turret
    end

    if i > 0 and i < 4 and j > 0 and j < 4 then
        parse("spawnobject 6 " .. (baseCenterX + i) .. " " .. (baseCenterY + j - 1) .. " 0 0 2 " .. id) -- Gate field
    end
end
